

#import "MonglotAppDelegate.h"

@implementation MonglotAppDelegate

@synthesize window;

/* local variables*/

int tmr=0;

/* this function is called when the application starts */
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	
	/*loading the included image */ 
	NSString* temp =  [[NSBundle mainBundle] pathForResource:@"Monglot" ofType:@"png"];
	inPath = [NSString stringWithFormat:@"%@",temp];
	[inPath retain];	/*this is the name if the image*/
	
	endFormat = [NSString stringWithFormat:@"png"]; /*this is the type of the image we're starting with */
	[endFormat retain];
	
	trans_endFormat = [NSString stringWithFormat:@""];
	[trans_endFormat retain];
	/*loading the image and showing it in the ui */
	NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inPath] autorelease];
	[imageView setImage:image];
	srand([tf_randomSeed integerValue]); /*setting the initial random value */
	
	globalNR = time(0);
	
	
	
	
	//Create the QT capture session
	QTCaptureSession *mCaptureSession = [[QTCaptureSession alloc] init];
	/* Select the default Video input device */
	QTCaptureDevice *iSight = [QTCaptureDevice defaultInputDeviceWithMediaType:QTMediaTypeVideo];
	
	/* Passing nil for the NSError parameter may not be the best idea
	 but i will leave error handling up to you */
	[iSight open:nil];
	/* Create a QTKit input for the session using the iSight Device */
	mCaptureDeviceInput = [QTCaptureDeviceInput deviceInputWithDevice:iSight];
	
	/* Create a capture session for the live vidwo and add inputs get the ball rolling etc */
	[mCaptureSession addInput:mCaptureDeviceInput error:nil];
	[outputCaptureView setCaptureSession:mCaptureSession];
	
	/* Let the video madness begin */
	[mCaptureSession startRunning]; 
	
	
	mCaptureDecompressedVideoOutput = [[QTCaptureDecompressedVideoOutput alloc] init];
	
	[mCaptureDecompressedVideoOutput setDelegate:self];
	
	[mCaptureSession addOutput:mCaptureDecompressedVideoOutput error:nil];
	
	
	
	
}

- (void)captureOutput:(QTCaptureOutput *)captureOutput didOutputVideoFrame:(CVImageBufferRef)videoFrame withSampleBuffer:(QTSampleBuffer *)sampleBuffer fromConnection:(QTCaptureConnection *)connection
{
	
    CVImageBufferRef imageBufferToRelease;
    CVBufferRetain(videoFrame);
    @synchronized (self) {
        imageBufferToRelease = mCurrentImageBuffer;
        mCurrentImageBuffer = videoFrame;
    }
    CVBufferRelease(imageBufferToRelease);
}

- (IBAction)GetWEBCAMImage:(id)sender
{
	CVImageBufferRef imageBuffer;
	

    @synchronized (self) {
	    imageBuffer = CVBufferRetain(mCurrentImageBuffer);
    }
	
	if (imageBuffer) {
        NSCIImageRep *imageRep = [NSCIImageRep imageRepWithCIImage:[CIImage imageWithCVImageBuffer:imageBuffer]];
        NSImage *image = [[[NSImage alloc] initWithSize:[imageRep size]] autorelease];

        [image addRepresentation:imageRep];
		
        CVBufferRelease(imageBuffer);
		[[image TIFFRepresentation ] writeToFile:@"/capture.tiff" atomically:NO];
		
		inPath = @"/capture.tiff";
		[inPath retain];
		endFormat = [NSString stringWithFormat:@"tiff"];
		[endFormat retain];
		
		[imageView setImage:image];

    }
	
	
	
}


/* this happens if someone presses the initialize button*/
- (IBAction)InitilizeRandom:(id)sender
{
	srand([tf_randomSeed integerValue]);
}

- (NSString*)doGlitch:(NSString*)inFileName and:(NSString*)outFileName
{
	/*   transcoding */
	
	if (trans_endFormat==@"png") {	
		
		NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inFileName] autorelease];
		[imageView setImage:image];
		[imageView setNeedsDisplay];
		
		// There are also TIFF, BMP, GIF, JPEG file types in addition to PNG.
		NSBitmapImageRep *bits =  [[NSBitmapImageRep alloc] initWithData:[[imageView image]  TIFFRepresentation]];
		//NSBitmapImageRep *bits = ; // get a rep from your image, or grab from a view
		NSData *data;
		data = [bits representationUsingType: NSPNGFileType  properties:[NSDictionary dictionaryWithObject:[NSNumber numberWithBool:TRUE] forKey:NSImageInterlaced]   ];
		[data writeToFile: @"/TEMP.png" atomically: NO];
		inPath=@"/TEMP.png";
		[inPath retain];
		endFormat=@"png";
		[endFormat retain];
		outFileName =[NSString stringWithFormat:@"%@.%@", outFileName, endFormat];
		
	}
	
	if (trans_endFormat==@"jpg") {	
		
		NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inFileName] autorelease];
		[imageView setImage:image];
		[imageView setNeedsDisplay];
		
		// There are also TIFF, BMP, GIF, JPEG file types in addition to PNG.
		NSBitmapImageRep *bits =  [[NSBitmapImageRep alloc] initWithData:[[imageView image]  TIFFRepresentation]];
		//NSBitmapImageRep *bits = ; // get a rep from your image, or grab from a view
		NSData *data;
		data = [bits representationUsingType: NSJPEGFileType properties: nil];
		[data writeToFile: @"/TEMP.jpg" atomically: NO];
		inPath=@"/TEMP.jpg";
		[inPath retain];
		endFormat=@"jpg";
		[endFormat retain];
		outFileName =[NSString stringWithFormat:@"%@.%@", outFileName, endFormat];
		
	}
	if (trans_endFormat==@"tiff") {	
		
		
		NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inFileName] autorelease];
		[imageView setImage:image];
		[imageView setNeedsDisplay];
		
		// There are also TIFF, BMP, GIF, JPEG file types in addition to PNG.
		NSBitmapImageRep *bits =  [[NSBitmapImageRep alloc] initWithData:[[imageView image]  TIFFRepresentation]];
		//NSBitmapImageRep *bits = ; // get a rep from your image, or grab from a view
		NSData *data;
		data = [bits representationUsingType: NSTIFFFileType properties: nil];
		[data writeToFile: @"/TEMP.tiff" atomically: NO];
		inPath=@"/TEMP.tiff";
		[inPath retain];
		endFormat=@"tiff";
		[endFormat retain];
		outFileName =[NSString stringWithFormat:@"%@.%@", outFileName, endFormat];
		
	}
	if (trans_endFormat==@"bmp") {	
		
		NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inFileName] autorelease];
		[imageView setImage:image];
		[imageView setNeedsDisplay];
		
		// There are also TIFF, BMP, GIF, JPEG file types in addition to PNG.
		NSBitmapImageRep *bits =  [[NSBitmapImageRep alloc] initWithData:[[imageView image]  TIFFRepresentation]];
		//NSBitmapImageRep *bits = ; // get a rep from your image, or grab from a view
		NSData *data;
		data = [bits representationUsingType: NSBMPFileType properties: nil];
		[data writeToFile: @"/TEMP.bmp" atomically: NO];
		inPath=@"/TEMP.bmp";
		[inPath retain];
		endFormat=@"bmp";
		[endFormat retain];
		outFileName =[NSString stringWithFormat:@"%@.%@", outFileName, endFormat];
		
	}
	if (trans_endFormat==@"gif") {	
		
		NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inFileName] autorelease];
		[imageView setImage:image];
		[imageView setNeedsDisplay];
		
		// There are also TIFF, BMP, GIF, JPEG file types in addition to PNG.
		NSBitmapImageRep *bits =  [[NSBitmapImageRep alloc] initWithData:[[imageView image]  TIFFRepresentation]];
		//NSBitmapImageRep *bits = ; // get a rep from your image, or grab from a view
		NSData *data;
		data = [bits representationUsingType: NSGIFFileType properties: nil];
		[data writeToFile: @"/TEMP.gif" atomically: NO];
		inPath=@"/TEMP.gif";
		[inPath retain];
		endFormat=@"gif";
		[endFormat retain];
		outFileName =[NSString stringWithFormat:@"%@.%@", outFileName, endFormat];
		
	}
	if (trans_endFormat==@"jp2") {	
		
		NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inFileName] autorelease];
		[imageView setImage:image];
		[imageView setNeedsDisplay];
		
		// There are also TIFF, BMP, GIF, JPEG file types in addition to PNG.
		NSBitmapImageRep *bits =  [[NSBitmapImageRep alloc] initWithData:[[imageView image]  TIFFRepresentation]];
		//NSBitmapImageRep *bits = ; // get a rep from your image, or grab from a view
		NSData *data;
		data = [bits representationUsingType: NSJPEG2000FileType properties: nil];
		[data writeToFile: @"/TEMP.jp2" atomically: NO];
		inPath=@"/TEMP.jp2";
		[inPath retain];
		endFormat=@"jp2";
		[endFormat retain];
		outFileName =[NSString stringWithFormat:@"%@.%@", outFileName, endFormat];
		
	}
	/*  end  transcoding */
 	
	
	
	[[NSFileManager defaultManager] createFileAtPath: outFileName
											contents: nil attributes: nil];
	
	
	NSFileHandle *outFile = [NSFileHandle fileHandleForWritingAtPath:outFileName];
	
	
	if (outFile == nil) {
		NSRunAlertPanel(outFileName,outFileName, @"Open of testout for writing failed",nil,nil);
		
		return outFileName;
	}
	
	/*we need to read the original file */
	NSData *inFile = [NSData dataWithContentsOfFile:inPath];
	
	
	/*setting some handy dandy variables*/
	
	NSUInteger len = [inFile length];
	Byte *byteData = (Byte*)malloc(len);
	Byte *byteData2 = (Byte*)malloc(len*2);
	memcpy(byteData, [inFile bytes], len);
	memcpy(byteData2, [inFile bytes], len);
	
	
	unsigned char A = [tf_from integerValue];
	unsigned char B = [tf_to integerValue];
	int conform = 100-[sl_chance intValue]; /*inverting the scale :)*/
	
	/*
	 jpg = 38
	 gif = 13
	 bmp = 14 alt 40
	 png=8
	 
	 so we'll go with 40
	 
	 */
	
	if([endFormat isEqualToString:@"bmp"] )
	{
		for (int i = 00 ; i< 40;i++)
		{
			byteData2[i]=byteData[i];
		}
		int ix=40;
		for (int i = 40 ; i< len;i++)
		{
			
			if(byteData[i]==0x07)
			{
				
				byteData2[ix++]=' ';
			}
			else if(byteData[i]==0x0A)
			{
				byteData2[ix++]='\r';
				byteData2[ix++]='\n';
			}
			else if(byteData[i]==0x0D)
			{
				byteData2[ix++]='\r';
				byteData2[ix++]='\n';
			}
			else if(byteData[i]==0x0B)
			{
				byteData2[ix++]='\r';
				byteData2[ix++]='\n';
			}
			else {
				byteData2[ix++]=byteData[i];
			}
		}
		byteData=byteData2;
		len =ix;
	}
	
	else if([endFormat isEqualToString:@"png"] ){
		byteData[rand()%len]=rand()%256;
		
	}
	
	else
	{
		for (int i = 40 ; i< len;i++)
		{
			if([bt_replace state])		/*this part here is for the search and replace */
			{
				if(byteData[i]==A)
					byteData[i]=B;
			}
			if(conform==0) /* if we want to conform, we dont do anything, bailing out, coward */
				break;
			if(i%conform==0) /*checking to se the amount of randomness we are applying */
				if (rand()%([sl_chance intValue]+1)==0)
				{
					//	byteData[i]=byteData[i-rand()%conform]; /*overwriting "good" data with something random*/
					byteData[i]=rand()%256; 
					
				}
		}
	}
	/* writing the out data */
	NSData *outData = [NSData dataWithBytes:byteData length:len];
	
	[outFile writeData: outData]; 
	[outFile closeFile];
	
	return outFileName;
}


/* bad name for a function, but this is the heart, it does all the glitching really :)
 Happens when someone pressed the effect/affect button */


- (IBAction)DoStuff:(id)sender
{
	
	tmr =0;
	globalNR++;
	int invalideTries=0;
	int frames=1;
	
	/*checking to se if the batch chexbox is checked, if it is, we're doing many glitches of the same file */
	if ([bt_batch state]==FALSE)
		frames=1;
	else {
		frames=[tf_numFrames integerValue];
	}
	
	/*creating the outputpath on the users home directory */
	NSString *createPath =[[NSString alloc] initWithFormat: @"%@/Documents/monglot/",NSHomeDirectory()];
	[[NSFileManager defaultManager] createDirectoryAtPath: createPath attributes: nil];
	
	/*starting to glitch*/
	for (int numberofframes =0;tmr<frames ;numberofframes++)
	{
 		/*making a file to write to*/
		NSString *outPath =[[NSString alloc] initWithFormat: @"%@/Documents/monglot/%i%i.%@",NSHomeDirectory(),globalNR,tmr,endFormat];
		
		outPath = [self doGlitch:inPath and:outPath];
		[outPath retain];
		/*trying to set the image*/
		NSImage *image = [[[NSImage alloc] initWithContentsOfFile:outPath] autorelease];
		
		if ([image isValid]) /* if it worked, change the next one*/
		{
			[imageView setImage:image];
			tmr++;
			invalideTries=0;
		}
		else  /*if it didnt, count up the nr of times we've tried*/
		{
			invalideTries++;
			if(invalideTries>10) /*if we tried to get a proper image more then 10 times, maybe we are glitching something else, move along */
			{
				tmr++;
				invalideTries=0;
			}
		}
		
	}
	
}


/* Handle a file dropped on the dock icon*/
- (BOOL)application:(NSApplication *)sender openFile:(NSString *)path
{
	/* remembering the path and file endings and setting the infile in the imageview */
	inPath = path;
	endFormat =  [path pathExtension];
	NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inPath] autorelease];
	[inPath retain];
	[endFormat retain];
	[imageView setImage:image];
    return YES;
}

/*this could be nice to use if we want to add a "show me the glitched files folder"-function*/
- (IBAction)OpenOutputFolder:(id)sender
{
	NSString *createPath =[[NSString alloc] initWithFormat: @"%@/Documents/monglot/",NSHomeDirectory()];
	[[NSFileManager defaultManager] createDirectoryAtPath: createPath
											   attributes: nil];
	[[NSWorkspace sharedWorkspace] selectFile:createPath inFileViewerRootedAtPath:nil];
	
}



/* loading a new image via the open function in the ui */
- (IBAction)LoadNewImage:(id)sender
{
	//1282*619
	
	//[imageView setBounds:CGRectMake(0, 0, 1282, 619)]; 
 	[imageView setBounds:CGRectMake(0, 0, 2111, 619)]; 
	
	int i; // Loop counter.
 	
	// Create the File Open Dialog class.
	NSOpenPanel* openDlg = [NSOpenPanel openPanel];
	
	// Enable the selection of files in the dialog.
	[openDlg setCanChooseFiles:YES];
	
	// Enable the selection of directories in the dialog.
	[openDlg setCanChooseDirectories:NO];
	//[openDlg setAllowedFileTypes:fileTypes];
	// Display the dialog.  If the OK button was pressed,
	// process the files.
	if ( [openDlg runModalForDirectory:nil file:nil] == NSOKButton )
	{
		// Get an array containing the full filenames of all
		// files and directories selected.
		NSArray* files = [openDlg filenames];
		
		// Loop through all the files and process them.
		for( i = 0; i < [files count]; i++ )
		{
			/* remembering the path and file endings and setting the infile in the imageview */
			NSString* fileName = [files objectAtIndex:i];
			
			inPath = fileName;
			endFormat =  [fileName pathExtension];
 			NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inPath] autorelease];
			[inPath retain];
			[endFormat retain];
			[imageView setImage:image];
			
 		}
	}
	
}


- (IBAction)GFD:(id)sender
{
	// open image array folder
	//make image array
	// call do stuff
 	
	NSString * inDir;
	NSString * outDir;
	
	/*get input directory*/
 	
	// Create the File Open Dialog class.
	NSOpenPanel* openDlg = [NSOpenPanel openPanel];
	
	// Enable the selection of files in the dialog.
	[openDlg setCanChooseFiles:NO];
	
	// Enable the selection of directories in the dialog.
	[openDlg setCanChooseDirectories:YES];
	[openDlg setCanCreateDirectories:YES];
	
	[openDlg setPrompt:@"Choose folder with images in"];
	if ( [openDlg runModalForDirectory:nil file:nil] == NSOKButton )
	{
		// Get an array containing the full filenames of all
		// files and directories selected.
		NSArray* files = [openDlg filenames];
		
		// Loop through all the files and process them.
		for( int i = 0; i < [files count]; i++ )
		{
			inDir=   [files objectAtIndex:i];
 		}
	}	
	else {
		return;
	}
	
	NSOpenPanel* openDlg2 = [NSOpenPanel openPanel];
	// Enable the selection of files in the dialog.
	[openDlg2 setCanChooseFiles:NO];
	
	// Enable the selection of directories in the dialog.
	[openDlg2 setCanChooseDirectories:YES];
	[openDlg2 setCanCreateDirectories:YES];
	
	[openDlg2 setPrompt:@"Choose folder destination"];
	if ( [openDlg2 runModalForDirectory:nil file:nil] == NSOKButton )
	{
		// Get an array containing the full filenames of all
		// files and directories selected.
		NSArray* files = [openDlg2 filenames];
		
		// Loop through all the files and process them.
		for( int i = 0; i < [files count]; i++ )
		{
			outDir=   [files objectAtIndex:i];
 		}
	}
	else {
		return;
	}
	
	
	
	/*get output directory*/
	
	
	
	
	NSError* error = nil;
	NSArray* imagesArray = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:inDir error:&error];
  	
	int i;
	int te=0;
	for (i = 0; i < [imagesArray count]; ++i)
	{
		NSString *fileName =[[NSString alloc] initWithFormat: @"%@/%@",outDir,[imagesArray objectAtIndex:i]];
		NSString *fileInName = [[NSString alloc] initWithFormat: @"%@/%@",inDir,[imagesArray objectAtIndex:i]];
		{
			inPath = fileInName;
			
			te=0;
			while ([[NSFileManager defaultManager] fileExistsAtPath:fileName]) {
 				fileName=[[NSString alloc] initWithFormat: @"%@/%d%@",outDir,te,[imagesArray objectAtIndex:i]];
				te++;
 			}
			
			if (endFormat=="") {
				endFormat =  [fileName pathExtension];
				[endFormat retain];
				
			}
			
			NSImage *image = [[[NSImage alloc] initWithContentsOfFile:inPath] autorelease];
			[inPath retain];
			[imageView setImage:image];
			fileName = [self doGlitch:inPath and:fileName];
			[fileName retain];
			
		}	
		
	}	
}

- (IBAction)FIT:(id)sender
{
	
	
	[imageView setBounds:CGRectMake(0, 0, 2111, 619)]; 
	
	
	float imagesizew= [[imageView image] size].width;
	float imageviewsizew =[imageView bounds].size.width ;
	
	float scalew = imageviewsizew / imagesizew;
	float imagesizeh= [[imageView image] size].height;
	float imageviewsizeh =[imageView bounds].size.height ;
	float scaleh = imageviewsizeh / imagesizeh;
	
	
	NSSize testSize;
	
	
	if(scaleh<scalew)
	{
		if(scaleh < 1.0)
		{
			testSize = NSMakeSize ([[imageView image] size].width *scaleh, [[imageView image] size].height * scaleh);
		}
		else 
		{
			testSize = NSMakeSize ([[imageView image] size].width *(int)scaleh, [[imageView image] size].height * (int)scaleh);
		}
	}
	else
	{
		if(scalew < 1.0)
		{
			testSize = NSMakeSize ([[imageView image] size].width *scalew, [[imageView image] size].height * scalew);
		}
		else 
		{
			testSize = NSMakeSize ([[imageView image] size].width *(int)scalew, [[imageView image] size].height * (int)scalew);
		}
	}
	[[imageView image] setSize: testSize];
	[imageView setNeedsDisplay];
	
	
}


- (IBAction)TRANSCODEchange:(id)sender
{
	
	NSString *tant = [popupbutton titleOfSelectedItem];
	if([tant isEqualToString:@"PNG"] )
	{
		trans_endFormat =  @"png";
	 	[trans_endFormat retain];
	}
	else if([tant isEqualToString:@"BMP"] )
	{
		trans_endFormat =  @"bmp";
	 	[trans_endFormat retain];
	}
	else if([tant isEqualToString:@"JPG"] )
	{
		trans_endFormat =  @"jpg";
	 	[trans_endFormat retain];
	}
	else if([tant isEqualToString:@"TIFF"] )
	{
		trans_endFormat =  @"tiff";
	 	[trans_endFormat retain];
	}
 	else if([tant isEqualToString:@"GIF"] )
	{
		trans_endFormat =  @"gif";
	 	[trans_endFormat retain];
	}
 	else if([tant isEqualToString:@"JPG 2000"] )
	{
		trans_endFormat =  @"jp2";
	 	[trans_endFormat retain];
	}
	else {
		endFormat =  [inPath pathExtension];
		trans_endFormat = [inPath pathExtension];
		[endFormat retain];
		[trans_endFormat retain];
		
	}
}



- (IBAction)ShowAbout:( id )sender
{
	
	NSDictionary *options;
	
	options = [NSDictionary dictionaryWithObjectsAndKeys:
			   @"" , @"Version" ,
			   @"Monglot" , @"ApplicationName" ,
			   [NSImage imageNamed:@"NSApplicationIcon"], @"ApplicationIcon" ,
			   @"01000111 01101100 01101001 01110100 01100011 01101000 01010011 01110000 01100101 01100001 01101011 00101100 00100000 01100001 01110011 00100000 01101111 01110000 01110000 01101111 01110011 01100101 01100100 00100000 01110100 01101111 00100000 01001110 01100101 01110111 01110011 01110000 01100101 01100001 01101011 00101110" , @"Copyright" ,
			   nil ];
	[[NSApplication sharedApplication] orderFrontStandardAboutPanelWithOptions:options];
	
}



@end
